#
# A few operations on the AVL tree
# Comparing AVL and BST trees

import avl
import bst

d = avl.dict()
b = bst.dict()

print("Inserting keys 7, 3")
d[7] = "CS206"
d[3] = "CS109"
b[7] = "CS206"
b[3] = "CS109"

print("d = %s" % d)
print("b = %s" % b)
print("d[3] = %s" % d[3])
print("d[7] = %s" % d[7])

print("Redefining key 7")
d[7] = "CS206A"
b[7] = "CS206A"

print("d = %s" % d)
print("b = %s" % b)
print("d[3] = %s" % d[3])
print("d[7] = %s" % d[7])

print("Inserting keys 13, 29")
d[13] = "CS300"
d[29] = "CS500"
b[13] = "CS300"
b[29] = "CS500"

print("d = %s" % d)
print("b = %s" % b)

print("Deleting key 13")
del d[13]
del b[13]

print("d = %s" % d)
print("b = %s" % b)

print("Inserting keys 5, 19, 17, 11")
d[5] = "CS101"
d[19] = "CS492"
d[17] = "CS408"
d[11] = "CS220"
b[5] = "CS101"
b[19] = "CS492"
b[17] = "CS408"
b[11] = "CS220"

print("d = %s" % d)
print("b = %s" % b)

print("Deleting key 17")
del d[17]
del b[17]

print("d = %s" % d)
print("b = %s" % b)

print("First key is %s" % d.firstkey())
print("Last key is %s" % d.lastkey())

print("Now testing an unbalanced insertion order (100 elements):")
e = avl.dict()
for i in range(1, 100):
  e[i] = str(i)
print("e = %s" % e)
print("Height of e is %d" % e._root.height)

print("Now testing an unbalanced insertion order (100000 elements):")
e = avl.dict()
for i in range(1, 100000):
  e[i] = str(i)
print("Height of e is %d" % e._root.height)
